
<!--- This file is automatically generated by make gen-cli-docs; changes should be made in the go CLI command code (under cmd/kops) -->

## kops edit

Edit clusters and other resources.

### Synopsis


Edit a resource configuration. This command changes the desired configuration in the registry. 

  To set your preferred editor, you can define the EDITOR environment variable.
  When you have done this, kops will use the editor that you have set.
  
  kops edit does not update the cloud resources, to apply the changes use "kops update cluster".

### Examples

```
  # Edit a cluster configuration.
  kops edit cluster k8s-cluster.example.com --state=s3://kops-state-1234
  
  # Edit a instance group configuration.
  kops edit ig --name k8s-cluster.example.com \
  --state=s3://kops-state-1234 nodes
```

### Options inherited from parent commands

```
      --alsologtostderr                  log to standard error as well as files
      --config string                    config file (default is $HOME/.kops.yaml)
      --log_backtrace_at traceLocation   when logging hits line file:N, emit a stack trace (default :0)
      --log_dir string                   If non-empty, write log files in this directory
      --logtostderr                      log to standard error instead of files (default false)
      --name string                      Name of cluster
      --state string                     Location of state storage
      --stderrthreshold severity         logs at or above this threshold go to stderr (default 2)
  -v, --v Level                          log level for V logs
      --vmodule moduleSpec               comma-separated list of pattern=N settings for file-filtered logging
```

### SEE ALSO
* [kops](kops.md)	 - kops is Kubernetes ops.
* [kops edit cluster](kops_edit_cluster.md)	 - Edit cluster.
* [kops edit instancegroup](kops_edit_instancegroup.md)	 - Edit instancegroup.

